#!/usr/bin/env python2.4

##system-logviewer
##
## Copyright (C) 2001-2004 Red Hat, Inc.
## Copyright (C) 2001-2004 Tammy Fox <tfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#Originally Written by Tammy Fox
#Last Modified May 1, 2003

## Coding conventions
## function names have underscores (_)
## variable names are semiStudlyCapped
## class names are StudlyCapped
## class instances are semiStudlyCapped

from gtk import *
import gtk
import os
import rhpl.iconv

class LogBuffer(gtk.TextBuffer):
    def __init__(self):
        self.buffer = gtk.TextBuffer(None)
        gtk.TextBuffer.__init__(self, None)

        baseSize = 10
        baseFont = 'sans'
        self.bodyTag = self.create_tag('body')
        self.bodyTag.set_property('font', '%s %d' % (baseFont, baseSize))
        self.bodyTag.set_property('pixels-above-lines', 1)
        self.bodyTag.set_property('pixels-below-lines', 1)
        self.codeset = 'utf-8'

    def set_buffer_text(self, text):
        self.set_text(text)
        self.apply_tags()

    def get_buffer(self):
        self.apply_tags()
        return self

    def get_buffer_line_count(self):
        return self.get_line_count()

    def insert_into_buffer_at_offset(self, iter, new_line):

#ja_JP:euc-jp, ko_KR:euc-kr, zh_TW:Big5, zh_CN:GB18030, western europe:iso-8859-1

        # if python's locale encoding aliases were not so broken this
        # would be the way to determine the default encoding
#       import locale
#         loc = locale.getdefaultlocale()
#       if loc[1]:
#          encoding = loc[1]

        langEnVar = os.environ["LANG"]
        lang = langEnVar.split(".")[0]
        encoding = "utf-8"

        try:
            #try utf-8
            theiconv = rhpl.iconv.open(self.codeset, encoding)
            line = theiconv.iconv(new_line)
            self.insert(iter, line)
        except:
            if lang == "ru_RU":
                try:
                    encoding =  "koi8-r"
                    theiconv = rhpl.iconv.open(self.codeset, encoding)
                    line = theiconv.iconv(new_line)
                    self.insert(iter, line)
                except:
                    theiconv = rhpl.iconv.open(self.codeset, 'iso-8859-1')
                    line = theiconv.iconv(new_line)
                    self.insert(iter, line)
            else:
                #try iso-8859-1
                encoding="iso-8859-1"
                try:
                    theiconv = rhpl.iconv.open(self.codeset, encoding)
                    line = theiconv.iconv(new_line)
                    self.insert(iter, "iso-8859-1")
                    self.insert(iter, line)
                except:
                    print 'unable to translate from', encoding, self.codeset
                    theiconv = rhpl.iconv.open(self.codeset, 'iso-8859-1')
                    try:
                        line = theiconv.iconv(new_line)
                        self.insert(iter, line)
                    except:
                        #last time to try and insert line
                        try:
                            self.insert(iter, line)
                        except:
                            errorMessage = (_("Unable to read log file with proper encoding."))
                            self.insert(iter, errorMessage)
                            return 0

        #return 1 if all goes well
        return 1

    def delete_from_buffer(self, start_iter, end_iter):
        self.delete(start_iter, end_iter)
    
    def set_iter(self, iter):
        self.iter = iter

    def apply_tags(self):
        start = self.get_iter_at_offset (0)
        end = self.get_end_iter()
        self.apply_tag(self.bodyTag, start, end)
