#!/usr/bin/env python2.4

##system-logviewer - preferences dialog box
##
## Copyright (C) 2001-2004 Red Hat, Inc.
## Copyright (C) 2001-2004 Tammy Fox <tfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#Originally Written by Tammy Fox
#Last Modified May 6, 2003

## Coding conventions
## function names have underscores (_)
## variable names are semiStudlyCapped
## class names are StudlyCapped
## class instances are semiStudlyCapped

from gtk import *
import string
import gtk
import signal
import gobject
import os
import time
import LogViewerGui
import LogFileClass
import LogFileFrame

##
## I18N
## 
import gettext
gettext.bindtextdomain ("system-logviewer", "/usr/share/locale")
gettext.textdomain ("system-logviewer")
_=gettext.gettext

##---------------------------------------------------------------

##---------------------------------------------------------------
##---------------------------------------------------------------

##
## Main Class
##

class Preferences:

## Init

    def __init__ (self, parentClass, configFile):
        self.configFile = configFile
        self.parentClass = parentClass
        self.preferences = gtk.Dialog(_("Preferences"))
	self.preferences.set_size_request(450, 400)
	self.preferences.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
	self.preferences.set_border_width(2)
	self.preferences.set_modal(gtk.TRUE)
        self.preferences.set_position(gtk.WIN_POS_CENTER_ON_PARENT)

        self.preferences.set_icon(LogViewerGui.iconPixbuf)

	#--------Preferences Notebook-------------------------------
 	self.prefsNotebook = gtk.Notebook()
 	self.prefsNotebook.set_show_tabs(gtk.TRUE)		
 	self.preferences.vbox.pack_start(self.prefsNotebook, gtk.TRUE, gtk.TRUE)
	
	#--------Log Files and Refresh Rate page----------------------
        self.logFilesVBox = gtk.VBox(gtk.FALSE, 6)
        self.logFilesVBox.set_border_width(6)
        self.logFilesFrame = gtk.Frame(_("Log Files"))
        self.logFilesFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.logFilesFrame.set_border_width(6)        

        self.lFdescriptionHBox = gtk.HBox(gtk.FALSE, 6)
        self.lFdescriptionHBox.set_border_width(2)

        prefsImage = gtk.Image()
        prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 5)

        self.lFdescriptionHBox.pack_start(prefsImage)

        label = gtk.Label(_("Configure the path and filename for each log file displayed."))
        label.set_line_wrap(gtk.TRUE)
        label.set_size_request(250, -1)
        self.lFdescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)

        self.logFilesVBox.pack_start(self.lFdescriptionHBox, gtk.FALSE, gtk.FALSE)

        self.logFilesScrollWindow = gtk.ScrolledWindow()
        self.logFilesScrollWindow.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        self.logFilesScrollWindow.set_shadow_type(gtk.SHADOW_ETCHED_IN)

	self.logFilesTreeView = gtk.TreeView(LogViewerGui.logFilesListStore)
        col = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=0)
        col.set_title(_("Log File"))
        col.set_visible(gtk.TRUE)
        col2 = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=1)
        col2.set_title(_("Location"))
        col2.set_visible(gtk.TRUE)
        self.logFilesTreeView.set_headers_visible(gtk.TRUE)
        self.logFilesTreeView.append_column(col)
        self.logFilesTreeView.append_column(col2)
        self.logFilesTreeView.set_border_width(8)
        selection = self.logFilesTreeView.get_selection()

        self.logFilesTreeView.set_rules_hint(gtk.TRUE)
        self.logFilesScrollWindow.add(self.logFilesTreeView)

        #Location buttons
        self.logFilesLocationsVBoxButtons = gtk.VBox(gtk.FALSE,3)
        self.editButton = gtk.Button(_("_Edit"))
        self.editButton.connect ("clicked", self.on_changed_clicked)
        self.addButton = gtk.Button(_("_Add"))
        self.addButton.connect ("clicked", self.on_add_clicked)
        self.deleteButton = gtk.Button(_("_Delete"))
        self.deleteButton.connect ("clicked", self.on_delete_logfile)
        self.logFilesLocationsVBoxButtons.pack_start(self.addButton, gtk.FALSE, gtk.FALSE)
        self.logFilesLocationsVBoxButtons.pack_start(self.editButton, gtk.FALSE, gtk.FALSE)
        self.logFilesLocationsVBoxButtons.pack_start(self.deleteButton, gtk.FALSE, gtk.FALSE)

        self.logFileLocationsHBox = gtk.HBox(gtk.FALSE, 10)
        self.logFileLocationsHBox.pack_start(self.logFilesScrollWindow, gtk.TRUE, gtk.TRUE)
        self.logFileLocationsHBox.pack_start(self.logFilesLocationsVBoxButtons, gtk.FALSE, gtk.FALSE)

        self.logFilesVBox.pack_start(self.logFileLocationsHBox, gtk.TRUE, gtk.TRUE)        

        self.logFilesFrame.add(self.logFilesVBox)

        #Refresh Rate spinner
        self.refreshRateFrame = gtk.Frame(_("Refresh Rate"))
        self.refreshRateFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.refreshRateFrame.set_border_width(6)      
        self.refreshRateLabel = gtk.Label(_("Refresh log file every "))
        self.refreshRateSpin = gtk.SpinButton(gtk.Adjustment(LogViewerGui.RefreshRate/1000,30,600,1,1,0), 0, 0)
        self.refreshRateSecLabel = gtk.Label(_("seconds."))
        self.refreshRateHBox = gtk.HBox(gtk.FALSE,3)
        self.refreshRateHBox.set_border_width(2)
        self.refreshRateHBox.pack_start(self.refreshRateLabel, gtk.FALSE, gtk.FALSE)
        self.refreshRateHBox.pack_start(self.refreshRateSpin, gtk.FALSE, gtk.FALSE)
        self.refreshRateHBox.pack_start(self.refreshRateSecLabel, gtk.FALSE, gtk.FALSE)

        self.refreshRateFrame.add(self.refreshRateHBox)

        self.logFilesVBox = gtk.VBox(gtk.FALSE,2)
        self.logFilesVBox.pack_start(self.logFilesFrame, gtk.TRUE, gtk.TRUE)
        self.logFilesVBox.pack_start(self.refreshRateFrame, gtk.FALSE, gtk.FALSE)
        label = gtk.Label(_("Log _Files"))
        label.set_use_underline(gtk.TRUE)
        self.prefsNotebook.append_page(self.logFilesVBox, label)
        

	#--------Alert Icon page---------------------------------------------
        self.alertsVBox = gtk.VBox(gtk.FALSE, 2)
        self.alertsVBox.set_border_width(6)
        self.alertsFrame = gtk.Frame(_("Alerts"))
        self.alertsFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.alertsFrame.set_border_width(6)

        self.alertsDescriptionHBox = gtk.HBox(gtk.FALSE, 6)
        self.alertsDescriptionHBox.set_border_width(2)

        icon = None
        try:
            icon = gtk.gdk.pixbuf_new_from_file("/usr/share/system-logviewer/pixmaps/alert-big.png")
        except:
            pass

        image = gtk.Image()
        if icon:
            image.set_from_pixbuf(icon)

        self.alertsDescriptionHBox.pack_start(image)

        label = gtk.Label(_("Show alert icon for the following key words."))
        label.set_line_wrap(gtk.TRUE)
        label.set_size_request(250, -1)
        self.alertsDescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)

        self.alertsVBox.pack_start(self.alertsDescriptionHBox, gtk.FALSE, gtk.FALSE)

        #list store that contains key words to alert
        self.alertsListStore = gtk.ListStore(gobject.TYPE_STRING)
        for word in LogViewerGui.alertWords:
            #insert word into liststore
            if string.strip(word) != "":
                iter = self.alertsListStore.append()
                self.alertsListStore.set_value(iter, 0, string.strip(word))

	self.alertsTreeView = gtk.TreeView(self.alertsListStore)
        col = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=0)
        col.set_visible(gtk.TRUE)
        self.alertsTreeView.set_headers_visible(gtk.FALSE)
        self.alertsTreeView.append_column(col)
        self.alertsTreeView.set_border_width(8)
        selection = self.alertsTreeView.get_selection()
##        selection.connect("changed", self.some_function)

        self.alertsHBox = gtk.HBox(gtk.FALSE, 10)
        
        self.alertsTreeView.set_rules_hint(gtk.TRUE)
        self.alertsScrollWindow = gtk.ScrolledWindow()
        self.alertsScrollWindow.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        self.alertsScrollWindow.set_shadow_type(gtk.SHADOW_ETCHED_IN)

        self.alertsScrollWindow.add(self.alertsTreeView)

        self.alertsHBox.pack_start(self.alertsScrollWindow, gtk.TRUE, gtk.TRUE)

        self.alertsButtonVBox = gtk.VBox(gtk.FALSE,2)
        self.alertsAddButton = gtk.Button(_("_Add"))
        self.alertsAddButton.connect ("clicked", self.on_add_alert)
        self.alertsDeleteButton = gtk.Button(_("_Delete"))
        self.alertsDeleteButton.connect ("clicked", self.on_delete_alert)
        self.alertsButtonVBox.pack_start(self.alertsAddButton, gtk.FALSE, gtk.FALSE)
        self.alertsButtonVBox.pack_start(self.alertsDeleteButton, gtk.FALSE, gtk.FALSE)
        self.alertsHBox.pack_start(self.alertsButtonVBox, gtk.FALSE, gtk.FALSE)

        self.alertsVBox.pack_start(self.alertsHBox)
        self.alertsFrame.add(self.alertsVBox)
        label = gtk.Label(_("A_lerts"))
        label.set_use_underline(gtk.TRUE)
        self.prefsNotebook.append_page(self.alertsFrame, label)
        

	#--------Warning Icon page---------------------------------------------
        self.warningsVBox = gtk.VBox(gtk.FALSE, 2)
        self.warningsVBox.set_border_width(6)
        self.warningsFrame = gtk.Frame(_("Warnings"))
        self.warningsFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.warningsFrame.set_border_width(6)

        self.warningsDescriptionHBox = gtk.HBox(gtk.FALSE, 6)
        self.warningsDescriptionHBox.set_border_width(2)

        icon = None
        try:
            icon = gtk.gdk.pixbuf_new_from_file("/usr/share/system-logviewer/pixmaps/warning-big.png")
        except:
            pass

        image = gtk.Image()
        if icon:
            image.set_from_pixbuf(icon)

        self.warningsDescriptionHBox.pack_start(image)

        label = gtk.Label(_("Show warning icon for the following key words."))
        label.set_line_wrap(gtk.TRUE)
        label.set_size_request(250, -1)
        self.warningsDescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)

        self.warningsVBox.pack_start(self.warningsDescriptionHBox, gtk.FALSE, gtk.FALSE)

        #list store that contains key words to warning
        self.warningsListStore = gtk.ListStore(gobject.TYPE_STRING)
        for word in LogViewerGui.warningWords:
            #insert word into liststore
            if string.strip(word) != "":
                iter = self.warningsListStore.append()
                self.warningsListStore.set_value(iter, 0, string.strip(word))

	self.warningsTreeView = gtk.TreeView(self.warningsListStore)
        col = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=0)
        col.set_visible(gtk.TRUE)
        self.warningsTreeView.set_headers_visible(gtk.FALSE)
        self.warningsTreeView.append_column(col)
        self.warningsTreeView.set_border_width(8)
        selection = self.warningsTreeView.get_selection()
##        selection.connect("changed", self.some_function)

        self.warningsHBox = gtk.HBox(gtk.FALSE, 10)
        
        self.warningsTreeView.set_rules_hint(gtk.TRUE)
        self.warningsScrollWindow = gtk.ScrolledWindow()
        self.warningsScrollWindow.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        self.warningsScrollWindow.set_shadow_type(gtk.SHADOW_ETCHED_IN)

        self.warningsScrollWindow.add(self.warningsTreeView)

        self.warningsHBox.pack_start(self.warningsScrollWindow, gtk.TRUE, gtk.TRUE)

        self.warningsButtonVBox = gtk.VBox(gtk.FALSE,2)
        self.warningsAddButton = gtk.Button(_("_Add"))
        self.warningsAddButton.connect ("clicked", self.on_add_warning)
        self.warningsDeleteButton = gtk.Button(_("_Delete"))
        self.warningsDeleteButton.connect ("clicked", self.on_delete_warning)
        self.warningsButtonVBox.pack_start(self.warningsAddButton, gtk.FALSE, gtk.FALSE)
        self.warningsButtonVBox.pack_start(self.warningsDeleteButton, gtk.FALSE, gtk.FALSE)
        self.warningsHBox.pack_start(self.warningsButtonVBox, gtk.FALSE, gtk.FALSE)

        self.warningsVBox.pack_start(self.warningsHBox)
        self.warningsFrame.add(self.warningsVBox)
        label = gtk.Label(_("_Warnings"))
        label.set_use_underline(gtk.TRUE)
        self.prefsNotebook.append_page(self.warningsFrame, label)

	#--------Display Properties page-------------------------------------
##         self.displayPropsVBox = gtk.VBox(gtk.FALSE, 6)
##         self.displayPropsFrame = gtk.Frame(_("Display Properties"))
##         self.displayPropsFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
##         self.displayPropsFrame.set_border_width(6)        

##         self.dPdescriptionHBox = gtk.HBox(gtk.FALSE, 6)
##         self.dPdescriptionHBox.set_border_width(2)

##         prefsImage = gtk.Image()
##         prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 3)

##         self.dPdescriptionHBox.pack_start(prefsImage)

##         label = gtk.Label(_("For files that contain time stamps, log messages before the selected date will not be displayed. [not yet implemented] The currently-viewed log file will automatically refresh according the refresh rate."))
##         label.set_line_wrap(gtk.TRUE)
##         label.set_size_request(250, -1)
##         self.dPdescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)
##         self.displayPropsVBox.pack_start(self.dPdescriptionHBox, gtk.FALSE, gtk.FALSE)

##         self.displayPropsFrame.add(self.displayPropsVBox)

##         self.refreshRateLabel = gtk.Label("Refresh Rate: ")
##         self.refreshRateSpin = gtk.SpinButton(gtk.Adjustment(LogViewerGui.RefreshRate/1000,30,600,1,1,0), 0, 0)
##         self.refreshRateSecLabel = gtk.Label("seconds")
##         self.refreshRateHBox = gtk.HBox(gtk.FALSE,3)
##         self.refreshRateHBox.set_border_width(2)
##         self.refreshRateHBox.pack_start(self.refreshRateLabel, gtk.FALSE, gtk.FALSE)
##         self.refreshRateHBox.pack_start(self.refreshRateSpin, gtk.FALSE, gtk.FALSE)
##         self.refreshRateHBox.pack_start(self.refreshRateSecLabel, gtk.FALSE, gtk.FALSE)
##         self.displayPropsVBox.pack_start(self.refreshRateHBox, gtk.FALSE, gtk.FALSE)
        
##         self.prefsNotebook.append_page(self.displayPropsFrame, gtk.Label(_("Display Properties")))

        
        #--------Buttons-------------------------------------------
        self.preferences.add_button("gtk-close", 0)

        #--------Show Dialog---------------------------------------
        self.preferences.show_all()

## Save Preferences and close preferences Dialog

    def on_close_clicked(self, *args):
        #update refresh rate value
        rr = self.refreshRateSpin.get_value()
        self.update_pref("REFRESHRATE", rr)
        #file locations changes have already when activated
        #hide prefs window
        self.preferences.hide()

## Close Preferences Dialog

    def on_cancel_clicked(self, *args):
        self.preferences.hide()

## Change Log File Location

    def on_changed_clicked(self, *args):
        #grab log file locations
        data, self.iter = self.logFilesTreeView.get_selection().get_selected()
        if self.iter == None:
            self.error_dialog(_("Please select a log file from the list."))
            return

        self.changeLocationDialog = gtk.Dialog(_("Log File Locations"))
        self.changeLocationDialog.set_size_request(350, 150)
        self.changeLocationDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
        self.changeLocationDialog.set_border_width(2)
        self.changeLocationDialog.set_modal(gtk.TRUE)
        self.changeLocationDialog.set_transient_for(self.preferences)
        self.changeLocationDialog.set_icon(LogViewerGui.iconPixbuf)
        self.changeLocationDialog.add_button("gtk-cancel", 1)
        self.changeLocationDialog.add_button("gtk-ok", 0)
        clLabel = gtk.Label(_("Please enter a new location for the %s.") % LogViewerGui.logFilesListStore.get_value(self.iter, 0) )
        clLabel.set_line_wrap(gtk.TRUE)
        clLabel.set_size_request(300, -1)
        logFileHBox = gtk.HBox(gtk.FALSE, 6)

        prefsImage = gtk.Image()
        prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 3)

        # Change file location dialog
        logFileHBox.pack_start(prefsImage, gtk.FALSE, gtk.FALSE)
        logFileHBox.pack_start(clLabel, gtk.TRUE, gtk.TRUE, 6)
        self.logFileLocationLabel = gtk.Label(_("Location: "))
        self.logFileLocationEntry = gtk.Entry()
        self.logFileLocationEntry.set_text(LogViewerGui.logFilesListStore.get_value(self.iter, 1))
        self.logFileLocationEntry.connect ("activate", self.set_location)
        logFileLocationButton = gtk.Button(_("Browse..."))
        logFileLocationButton.connect("clicked", self.on_browse_clicked)
        logFileLocationHBox = gtk.HBox(gtk.FALSE, 6)
        logFileLocationHBox.pack_start(self.logFileLocationLabel, gtk.FALSE)
        logFileLocationHBox.pack_start(self.logFileLocationEntry, gtk.TRUE)
        logFileLocationHBox.pack_start(logFileLocationButton, gtk.FALSE, gtk.FALSE)
        self.changeLocationDialog.vbox.pack_start(logFileHBox, gtk.TRUE)
        self.changeLocationDialog.vbox.pack_start(logFileLocationHBox, gtk.TRUE, gtk.FALSE)
        
        self.changeLocationDialog.show_all()
        rc = self.changeLocationDialog.run()
        if rc == 0:
            logFileLocation = string.strip(self.logFileLocationEntry.get_text())
            #update list store with new location
            LogViewerGui.logFilesListStore.set_value(self.iter, 1, logFileLocation)
            #update list store boolean that location has changed
            LogViewerGui.logFilesListStore.set_value(self.iter, 3, 1)
            #update pref file
            self.update_pref(LogViewerGui.logFilesListStore.get_value(self.iter, 2), logFileLocation)
            self.changeLocationDialog.hide()
        elif rc == 1:
            self.changeLocationDialog.hide()

    def set_location(self, args):
        logFileLocation = string.strip(self.logFileLocationEntry.get_text())
        #update list store with new location
        LogViewerGui.logFilesListStore.set_value(self.iter, 1, logFileLocation)
        #update list store boolean that location has changed
        LogViewerGui.logFilesListStore.set_value(self.iter, 3, 1)
        #update pref file
        self.update_pref(LogViewerGui.logFilesListStore.get_value(self.iter, 2), logFileLocation)
        self.changeLocationDialog.hide()

## Add Log File Location

    def on_add_clicked(self, *args):
        addLocationDialog = gtk.Dialog(_("New Location"))
        addLocationDialog.set_size_request(350, 190)
        addLocationDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
        addLocationDialog.set_border_width(2)
        addLocationDialog.set_modal(gtk.TRUE)
        addLocationDialog.set_transient_for(self.preferences)
        addLocationDialog.set_icon(LogViewerGui.iconPixbuf)
        addLocationDialog.add_button("gtk-cancel", 1)
        addLocationDialog.add_button("gtk-ok", 0)
        clLabel = gtk.Label(_("Specify a new log file location.")) 
        clLabel.set_line_wrap(gtk.TRUE)
        clLabel.set_size_request(300, -1)
        newFileHBox = gtk.HBox(gtk.FALSE, 6)

        prefsImage = gtk.Image()
        prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 3)

        #Add file location dialog
        newFileHBox.pack_start(prefsImage, gtk.FALSE, gtk.FALSE)
        newFileHBox.pack_start(clLabel, gtk.TRUE, gtk.TRUE, 6)
        
        newFileNameLabel = gtk.Label(_("Name:"))
        newFileNameLabel.set_alignment(1.0, 0.0)
        newFileNameEntry = gtk.Entry()
        newFileDescriptionLabel = gtk.Label(_("Description:"))
        newFileDescriptionLabel.set_alignment(1.0, 0.0)
        newFileDescriptionEntry = gtk.Entry()
        newFileLocationLabel = gtk.Label(_("Location:"))
        newFileLocationLabel.set_alignment(1.0, 0.0)
        newFileLocationEntry = gtk.Entry()
        newFileLocationButton = gtk.Button(_("Browse..."))
        newFileLocationButton.connect("clicked", self.on_browse_clicked)

        addFileTable = gtk.Table(rows=3,columns=2)
        addFileTable.set_homogeneous(gtk.FALSE)
        addFileTable.set_row_spacings(3)
        addFileTable.set_col_spacings(3)

        #attach(child,left_attach,right_attach,top_attach,bottom_attach)
        addFileTable.attach(newFileNameLabel, 0, 1, 0, 1)
        addFileTable.attach(newFileNameEntry, 1, 2, 0, 1)
        addFileTable.attach(newFileDescriptionLabel, 0, 1, 1, 2)
        addFileTable.attach(newFileDescriptionEntry, 1, 2, 1, 2)
        addFileTable.attach(newFileLocationLabel, 0, 1, 2, 3)
        addFileTable.attach(newFileLocationEntry, 1, 2, 2, 3)

        addLocationDialog.vbox.pack_start(newFileHBox, gtk.FALSE, gtk.FALSE)
        addLocationDialog.vbox.pack_start(addFileTable, gtk.FALSE, gtk.FALSE)
        addLocationDialog.vbox.set_spacing(15)
        
        addLocationDialog.show_all()
        rc = addLocationDialog.run()
        if rc == 0:
            self.add_location(string.strip(newFileNameEntry.get_text()),
                              string.strip(newFileDescriptionEntry.get_text()),
                              string.strip(newFileLocationEntry.get_text()))
            addLocationDialog.hide()
        elif rc == 1:
            addLocationDialog.hide()

    def add_location(self, logFileName,logFileDescription,logFileLocation):
        #create unique key name
        key = "USERDEF%s"%(LogViewerGui.prefsNum)
        #add location to logDict
        LogViewerGui.logDict[key] = [logFileLocation]
        #bump USERDEF number
        LogViewerGui.prefsNum = LogViewerGui.prefsNum + 1

        ## stuff to do even if file doesn't exist ##

        #create instance of LogFileClass
        logClassInstance = LogFileClass.LogFileClass(key)

        #create instance of LogFileFrame
        logFrame = LogFileFrame.LogFileFrame(logFileName, logFileDescription, logClassInstance)

        #complete logDict entry
        LogViewerGui.logDict[key] = LogViewerGui.logDict[key] + [logClassInstance, logFrame, logFileName]

        #add to stringDict
        LogViewerGui.stringDict[key] = [logFileName,logFileDescription]

        #write to configuration file
        self.add_log_to_config(key,logFileLocation, logFileName, logFileDescription)
        
        #update list store with new file info:
        #descriptive string, file location, keyword, location changed (0=FALSE), notebook page number
        ## stuff to do if file exist so it shows up automatically in GUI##
        if LogViewerGui.logDict[key][1].get_file_not_found() == 0:
            # set list store values
            iter = LogViewerGui.logFilesListStore.append()
            self.parentClass.set_liststore_values(LogViewerGui.stringDict[key][0], key, iter)
            #update list store boolean that location has changed
            LogViewerGui.logFilesListStore.set_value(iter, 3, 1)

            #append to notebook
            LogViewerGui.logFileNotebook.append_page(LogViewerGui.logDict[key][2].get_frame(), gtk.Label(""))
            #refresh notebook b/c it doesn't do it by itself like the other widgets
            LogViewerGui.logFileNotebook.show_all()

## Add new log file to preferences file

    def add_log_to_config(self, key, location, name, description):
        newLine = "USERDEF=" + location + "," + name + "," + description
        #read in prefs file
        try:
            prefsFile = open(self.configFile, "r")
            prefsLines = prefsFile.readlines()
            prefsFile.close()
            try:
                os.rename(self.configFile, self.configFile + (".bak"))
            except:
                self.error_dialog(_("Error while trying to backup configuration file."))
                return
            #append new log file preference
            try:
                prefsFile = open(self.configFile, "w")
                prefsLines.append(newLine)
                for line in prefsLines:
                    prefsFile.write(line)
                prefsFile.write("\n")
                prefsFile.close()
            except:
                self.error_dialog(_("Error while writing to preferences file."))
                return
        except: #can't read in prefs file
            self.dialog(_("Preferences file not found."))
            return
          
## Browse for new log file location

    def on_browse_clicked(self, *args):
        ## not finished
        self.logFileSelection = gtk.FileSelection(_("Select Log File"))
        self.logFileSelection.set_filename("/var/")
        self.logFileSelection.ok_button.connect("clicked", self.on_ok_file_selected)
        self.logFileSelection.cancel_button.connect("clicked", self.on_cancel_file_selected)
        self.logFileSelection.connect("delete_event", self.on_cancel_file_selected)
        self.logFileSelection.set_modal(gtk.TRUE)
        self.logFileSelection.set_transient_for(self.preferences)
        self.logFileSelection.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.logFileSelection.show()

## Click ok in file selection dialog
        
    def on_ok_file_selected(self, *args):
        self.logFileLocationEntry.set_text(string.strip(self.logFileSelection.get_filename()))
        self.logFileSelection.hide()

## Click cancel in file selection dialog

    def on_cancel_file_selected(self, *args):
        self.logFileSelection.hide()

## Called by LogViewerGui to show Preferences Dialog

    def launch(self):
        return self.preferences

    def update_pref(self, prefToUpdate, value):
        #REMALERTWORD is used to delete alert word
        #REMWARNINGWORD is used to delete alert word
        #read in values in prefs file
        try:
            prefsFile = open(self.configFile, "r")
            prefsLines = prefsFile.readlines()
            prefsFile.close()
        except:
            self.error_dialog(_("Preferences file not found."))
            #don't go through rest of function
            return

        #LogViewerGui.alertWords already contains the new list of alert words

        #read in existing values
        try:
            prefsFile = open(self.configFile, "r")
            prefsLines = prefsFile.readlines()
            prefsFile.close()
        except:
            self.error_dialog(_("Error while trying to write to configuration file."))

        #backup file *after* reading in existing values
        try:
            os.rename(self.configFile, self.configFile + ".bak")
        except:
            self.error_dialog(_("Error while trying to backup configuration file."))

        #special case since older versions of system-logviewer
        #didn't have warning words
        if prefToUpdate == "WARNINGWORDS":
            count = 0
            found = 0
            for line in prefsLines:
                line = string.strip(line)
                #skip comments marked with #
                if line != "" and line[0]!="#":
                    preference, oldvalue = string.split(line,"=")
                    preference = string.strip(preference)
                    oldvalue = string.strip(oldvalue)
                    if preference == "WARNINGWORDS":
                        if oldvalue != '':
                            prefsLines[count] = line + "," + value + "\n"
                        else:
                            #no previous words in file
                            prefsLines[count] = line + value + "\n"
                        found = 1
                        break
                count = count + 1

            #line doesn't exist
            if found == 0:
                newWarningWords = "WARNINGWORDS=" + value + "\n"
                prefsLines.append(newWarningWords)
               
        #handle removing warning words
        elif prefToUpdate == "REMWARNINGWORDS":
            count = 0
            found = 0
            for line in prefsLines:
                line = string.strip(line)
                #skip comments marked with #
                if line != "" and line[0]!="#":
                    preference, oldvalue = string.split(line,"=")
                    preference = string.strip(preference)
                    oldvalue = string.strip(oldvalue)
                    if preference == "WARNINGWORDS":
                        newWarningWords = "WARNINGWORDS="
                        length = len(LogViewerGui.warningWords)
                        for word in LogViewerGui.warningWords:
                            if length == 1:
                                #if last word, don't add comma to end
                                newWarningWords = newWarningWords + word
                            else:
                                newWarningWords = newWarningWords + word + ","
                                length = length - 1
                        prefsLines[count] = newWarningWords + "\n"
                        break
                count = count + 1

        #add an alert word
        elif prefToUpdate == "ALERTWORDS":
            count = 0
            found = 0
            for line in prefsLines:
                line = string.strip(line)
                #skip comments marked with #
                if line != "" and line[0]!="#":
                    preference, oldvalue = string.split(line,"=")
                    preference = string.strip(preference)
                    oldvalue = string.strip(oldvalue)
                    if preference == "ALERTWORDS":
                        if oldvalue != '':
                            prefsLines[count] = line + "," + value + "\n"
                        else:
                            #no previous words in file
                            prefsLines[count] = line + value + "\n"
                        found = 1
                        break
                count = count + 1

            #line doesn't exist
            if found == 0:
                newAlertWords = "ALERTWORDS=" + value + "\n"
                prefsLines.append(newAlertWords)

        #handle removing alert words
        elif prefToUpdate == "REMALERTWORDS":
            count = 0
            found = 0
            for line in prefsLines:
                line = string.strip(line)
                #skip comments marked with #
                if line != "" and line[0]!="#":
                    preference, oldvalue = string.split(line,"=")
                    preference = string.strip(preference)
                    oldvalue = string.strip(oldvalue)
                    if preference == "ALERTWORDS":
                        newAlertWords = "ALERTWORDS="
                        length = len(LogViewerGui.alertWords)
                        for word in LogViewerGui.alertWords:
                            if length == 1:
                                #if last word, don't add comma to end
                                newAlertWords = newAlertWords + word
                            else:
                                newAlertWords = newAlertWords + word + ","
                                length = length - 1
                        prefsLines[count] = newAlertWords + "\n"
                        break
                count = count + 1

        #other than alert or warning word update
        else:
            #modify entry in prefsLines that has changed
            count = 0
            for line in prefsLines:
                line = string.strip(line)
                #skip comments marked with #
                if line != "" and line[0]!="#":
                    preference, oldvalue = string.split(line,"=")
                    preference = string.strip(preference)
                    oldvalue = string.strip(oldvalue)

                    #update refreshrate
                    if prefToUpdate == "REFRESHRATE" and preference == "REFRESHRATE":
                        prefsLines[count] = string.replace(line, oldvalue, str(int(value)) + "\n")
                        LogViewerGui.RefreshRate = int(value)*1000
                        if LogViewerGui.RefreshRate < 30000:
                            LogViewerGui.RefreshRate = 30000
                        break

                    #change log file location
                    elif (string.find(prefToUpdate, preference)) > -1:
                        #log file location preference
                        prefsLines[count] = string.replace(line, LogViewerGui.logDict[prefToUpdate][0], value) + "\n"
                        LogViewerGui.logDict[prefToUpdate][0] = value
                        #auto_refresh if location changes
                        LogViewerGui.logDict[prefToUpdate][1].auto_refresh()
                        #refresh frame buffer
                        LogViewerGui.logDict[prefToUpdate][2].set_buffer(LogViewerGui.logDict[prefToUpdate][1].buffer.get_buffer())
                        break

                count = count + 1

        #end of else statement for updating preferences


        #write prefs back to file
        try:
            prefsFile = open(self.configFile, "w")
            for line in prefsLines:
                prefsFile.write(line)
            prefsFile.close()
        except:
            self.error_dialog(_("Error while trying to write to configuration file."))
        

## Error dialog

    def error_dialog (self, errorMsg):
        dialog = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, errorMsg)
        dialog.set_title = (_("Error"))
        dialog.set_default_size(100,100)
        dialog.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        dialog.set_border_width(2)
        dialog.set_modal(gtk.TRUE)
        dialog.set_transient_for(self.preferences)
        dialog.set_icon(LogViewerGui.iconPixbuf)
        dialog.set_has_separator(gtk.FALSE)
        rc = dialog.run()
        if rc == gtk.RESPONSE_OK:
            dialog.hide()

## Add alert keyword

    def on_add_alert (self, *args):
        self.addAlertsDialog = gtk.Dialog(_("Add Alert Word"))
        self.addAlertsDialog.set_default_size(100, 100)
        self.addAlertsDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
        self.addAlertsDialog.set_border_width(2)
        self.addAlertsDialog.set_modal(gtk.TRUE)
        self.addAlertsDialog.set_transient_for(self.preferences)
        self.addAlertsDialog.set_icon(LogViewerGui.iconPixbuf)
        self.addAlertsDialog.set_has_separator(gtk.FALSE)
        label = gtk.Label(_("Enter a word to add to the list of alert words."))
        addAlertsVBox = gtk.VBox(gtk.FALSE, 6)
        addAlertsVBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)
        self.alertsEntry = gtk.Entry()
        self.alertsEntry.connect ("activate", self.add_alert)

        alertsCancelButton = self.addAlertsDialog.add_button('gtk-cancel', 0)
        alertsCancelButton.connect ("clicked", self.on_cancel_alert)        
                                          
        alertsOKButton = self.addAlertsDialog.add_button('gtk-ok', 0)
        alertsOKButton.connect ("clicked", self.add_alert)
                                         
        addAlertsVBox.pack_start(self.alertsEntry, gtk.TRUE, gtk.TRUE, 6)

        self.addAlertsDialog.vbox.pack_start(addAlertsVBox, gtk.TRUE)
        self.addAlertsDialog.show_all()

    def on_cancel_alert(self, *args):
        self.addAlertsDialog.destroy()
        
    def add_alert(self, *args):
        alert = string.strip(self.alertsEntry.get_text())
        if string.find(alert,',') > -1 or string.find(alert,'=') > -1:
            self.error_dialog(_("Alert word can not contain a comma (,) or equals sign (=)."))
            return
        if alert != "":
            #add to liststore
            iter = self.alertsListStore.append()
            self.alertsListStore.set_value(iter, 0, alert)
            #add to alertWords
            LogViewerGui.alertWords.append(alert)
            #add to prefs file
            self.update_pref("ALERTWORDS", alert)
            #hide dialog
            self.addAlertsDialog.hide()
        else:
            self.error_dialog(_("Please specify an alert word to add."))
            return

## Delete alert keyword

    def on_delete_alert (self, *args):
        #grab selected alert word
        data, iter = self.alertsTreeView.get_selection().get_selected()
        if iter == None:
            self.error_dialog(_("Please select an alert word from the list."))
            return

        alert = data.get_value(iter, 0)
        #delete from ListStore to delete from TreeView
        data.remove(iter)
        #delete from alertWords
        LogViewerGui.alertWords.remove(alert)
        #delete from prefs file
        self.update_pref("REMALERTWORDS", alert)

## Delete Log File Location

    def on_delete_logfile(self, *args):
        listStore, treeIter = self.logFilesTreeView.get_selection().get_selected()
                        
        if treeIter == None:
            self.error_dialog(_("Please select a log file from the list."))
            return

        #get user-friendly name of log file to delete
        logName = listStore.get_value(treeIter, 0)

        iter = LogViewerGui.logFilesListStore.get_iter_root()
        #get correct iter
        while iter:
            if LogViewerGui.logFilesListStore.get_value(iter, 0) == logName:
                #delete logfile according to keyword from config file
                self.delete_logfile(LogViewerGui.logFilesListStore.get_value(iter,2), LogViewerGui.logFilesListStore.get_value(iter,1))
                #remove from notebook
                LogViewerGui.logFileNotebook.remove_page(LogViewerGui.logFilesListStore.get_value(iter,4))
                LogViewerGui.logFileNotebook.show_all()
                #remove from liststore
                LogViewerGui.logFilesListStore.remove(iter)
                break
            iter = LogViewerGui.logFilesListStore.iter_next(iter)

    def delete_logfile(self, key, location):
        try:
            prefsFile = open(self.configFile, "r")
            prefsLines = prefsFile.readlines()
            prefsFile.close()
        except:
            self.error_dialogerror_dialog(_("Error reading preferences file."))

        try:
            os.rename(self.configFile, self.configFile + ".bak")
        except:
            self.error_dialog(_("Error while backing up configuration file."))


        count = 0
        for line in prefsLines:
            line = string.strip(line)
            if line != "" and line[0] != "#":
                if string.find(line, "USERDEF") > -1 and string.find(line, location) > -1:
                    prefsLines[count] = "\n"
            else: #not a user-defined log
                if string.find(line, key) > -1:
                    prefsLines[count] = "\n"

            count  = count + 1
                        
        try:
            prefsFile = open(self.configFile, "w")
            for line in prefsLines:
                prefsFile.write(line)
            prefsFile.close()
        except:
            self.error_dialog(_("Error reading preferences file."))

## Add warning keyword

    def on_add_warning (self, *args):
        self.addWarningDialog = gtk.Dialog(_("Add Warning Word"))
        self.addWarningDialog.set_default_size(100, 100)
        self.addWarningDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
        self.addWarningDialog.set_border_width(2)
        self.addWarningDialog.set_modal(gtk.TRUE)
        self.addWarningDialog.set_transient_for(self.preferences)
        self.addWarningDialog.set_icon(LogViewerGui.iconPixbuf)
        self.addWarningDialog.set_has_separator(gtk.FALSE)
        label = gtk.Label(_("Enter a word to add to the list of warning words."))
        addWarningsVBox = gtk.VBox(gtk.FALSE, 6)
        addWarningsVBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)
        self.warningsEntry = gtk.Entry()
        self.warningsEntry.connect ("activate", self.add_warning)

        cancelButton = self.addWarningDialog.add_button('gtk-cancel', 0)
        cancelButton.connect ("clicked", self.on_cancel_warning)        
                                          
        OKButton = self.addWarningDialog.add_button('gtk-ok', 0)
        OKButton.connect ("clicked", self.add_warning)
                                         
        addWarningsVBox.pack_start(self.warningsEntry, gtk.TRUE, gtk.TRUE, 6)

        self.addWarningDialog.vbox.pack_start(addWarningsVBox, gtk.TRUE)
        self.addWarningDialog.show_all()

    def on_cancel_warning(self, *args):
        self.addWarningDialog.destroy()
        
    def add_warning(self, *args):
        warning = string.strip(self.warningsEntry.get_text())
        if string.find(warning,',') > -1 or string.find(warning,'=') > -1:
            self.error_dialog(_("Warning word can not contain a comma (,) or equals sign (=)."))
            return
        if warning != "":
            #add to liststore
            iter = self.warningsListStore.append()
            self.warningsListStore.set_value(iter, 0, warning)
            #add to warningWords
            LogViewerGui.warningWords.append(warning)
            #add to prefs file
            self.update_pref("WARNINGWORDS", warning)
            #hide dialog
            self.addWarningDialog.hide()
        else:
            self.error_dialog(_("Please specify an warning word to add."))
            return

## Delete warning keyword

    def on_delete_warning (self, *args):
        #grab selected warning word
        data, iter = self.warningsTreeView.get_selection().get_selected()
        if iter == None:
            self.error_dialog(_("Please select an warning word from the list."))
            return

        warning = data.get_value(iter, 0)
        #delete from ListStore to delete from TreeView
        data.remove(iter)
        #delete from warningWords
        LogViewerGui.warningWords.remove(warning)
        #delete from prefs file
        self.update_pref("REMWARNINGWORDS", warning)

##---------------------------------------------------------------
##--------------------------------------------------------------
